# WARNING: Please don't edit this file. It was generated by Python/WinRT v2.0.0-beta.1

import datetime
import sys
import types
import typing
import uuid as _uuid
from builtins import property as _property

import winrt._winrt
import winrt.system
import winrt.windows.foundation
import winrt.windows.foundation.collections
import winrt.windows.security.credentials
import winrt.windows.system
import winrt.windows.ui
import winrt.windows.ui.shell

from winrt.windows.applicationmodel.useractivities import UserActivityState

Self = typing.TypeVar('Self')

class UserActivity_Static(type):
    def to_json_array(cls, activities: typing.Iterable[UserActivity], /) -> str: ...
    def try_parse_from_json(cls, json: str, /) -> typing.Optional[UserActivity]: ...
    def try_parse_from_json_array(cls, json: str, /) -> typing.Optional[winrt.windows.foundation.collections.IVector[UserActivity]]: ...

class UserActivity(winrt.system.Object, metaclass=UserActivity_Static):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> UserActivity: ...
    def __new__(cls: typing.Type[UserActivity], activity_id: str) -> UserActivity:...
    def create_session(self) -> typing.Optional[UserActivitySession]: ...
    def save_async(self) -> winrt.windows.foundation.IAsyncAction: ...
    def to_json(self) -> str: ...
    @_property
    def fallback_uri(self) -> typing.Optional[winrt.windows.foundation.Uri]: ...
    @fallback_uri.setter
    def fallback_uri(self, value: typing.Optional[winrt.windows.foundation.Uri]) -> None: ...
    @_property
    def content_uri(self) -> typing.Optional[winrt.windows.foundation.Uri]: ...
    @content_uri.setter
    def content_uri(self, value: typing.Optional[winrt.windows.foundation.Uri]) -> None: ...
    @_property
    def content_type(self) -> str: ...
    @content_type.setter
    def content_type(self, value: str) -> None: ...
    @_property
    def content_info(self) -> typing.Optional[IUserActivityContentInfo]: ...
    @content_info.setter
    def content_info(self, value: typing.Optional[IUserActivityContentInfo]) -> None: ...
    @_property
    def activation_uri(self) -> typing.Optional[winrt.windows.foundation.Uri]: ...
    @activation_uri.setter
    def activation_uri(self, value: typing.Optional[winrt.windows.foundation.Uri]) -> None: ...
    @_property
    def activity_id(self) -> str: ...
    @_property
    def state(self) -> UserActivityState: ...
    @_property
    def visual_elements(self) -> typing.Optional[UserActivityVisualElements]: ...
    @_property
    def is_roamable(self) -> bool: ...
    @is_roamable.setter
    def is_roamable(self, value: bool) -> None: ...

class UserActivityAttribution(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> UserActivityAttribution: ...
    @typing.overload
    def __new__(cls: typing.Type[UserActivityAttribution], icon_uri: typing.Optional[winrt.windows.foundation.Uri]) -> UserActivityAttribution:...
    @typing.overload
    def __new__(cls: typing.Type[UserActivityAttribution]) -> UserActivityAttribution:...
    @_property
    def icon_uri(self) -> typing.Optional[winrt.windows.foundation.Uri]: ...
    @icon_uri.setter
    def icon_uri(self, value: typing.Optional[winrt.windows.foundation.Uri]) -> None: ...
    @_property
    def alternate_text(self) -> str: ...
    @alternate_text.setter
    def alternate_text(self, value: str) -> None: ...
    @_property
    def add_image_query(self) -> bool: ...
    @add_image_query.setter
    def add_image_query(self, value: bool) -> None: ...

class UserActivityChannel_Static(type):
    def disable_auto_session_creation(cls) -> None: ...
    def get_default(cls) -> typing.Optional[UserActivityChannel]: ...
    def get_for_user(cls, user: typing.Optional[winrt.windows.system.User], /) -> typing.Optional[UserActivityChannel]: ...
    def try_get_for_web_account(cls, account: typing.Optional[winrt.windows.security.credentials.WebAccount], /) -> typing.Optional[UserActivityChannel]: ...

class UserActivityChannel(winrt.system.Object, metaclass=UserActivityChannel_Static):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> UserActivityChannel: ...
    def delete_activity_async(self, activity_id: str, /) -> winrt.windows.foundation.IAsyncAction: ...
    def delete_all_activities_async(self) -> winrt.windows.foundation.IAsyncAction: ...
    def get_or_create_user_activity_async(self, activity_id: str, /) -> winrt.windows.foundation.IAsyncOperation[UserActivity]: ...
    def get_recent_user_activities_async(self, max_unique_activities: winrt.system.Int32, /) -> winrt.windows.foundation.IAsyncOperation[winrt.windows.foundation.collections.IVector[UserActivitySessionHistoryItem]]: ...
    def get_session_history_items_for_user_activity_async(self, activity_id: str, start_time: datetime.datetime, /) -> winrt.windows.foundation.IAsyncOperation[winrt.windows.foundation.collections.IVector[UserActivitySessionHistoryItem]]: ...

class UserActivityContentInfo_Static(type):
    def from_json(cls, value: str, /) -> typing.Optional[UserActivityContentInfo]: ...

class UserActivityContentInfo(winrt.system.Object, metaclass=UserActivityContentInfo_Static):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> UserActivityContentInfo: ...
    def to_json(self) -> str: ...

class UserActivityRequest(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> UserActivityRequest: ...
    def set_user_activity(self, activity: typing.Optional[UserActivity], /) -> None: ...

class UserActivityRequestManager_Static(type):
    def get_for_current_view(cls) -> typing.Optional[UserActivityRequestManager]: ...

class UserActivityRequestManager(winrt.system.Object, metaclass=UserActivityRequestManager_Static):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> UserActivityRequestManager: ...
    def add_user_activity_requested(self, handler: winrt.windows.foundation.TypedEventHandler[UserActivityRequestManager, UserActivityRequestedEventArgs], /) -> winrt.windows.foundation.EventRegistrationToken: ...
    def remove_user_activity_requested(self, token: winrt.windows.foundation.EventRegistrationToken, /) -> None: ...

class UserActivityRequestedEventArgs(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> UserActivityRequestedEventArgs: ...
    def get_deferral(self) -> typing.Optional[winrt.windows.foundation.Deferral]: ...
    @_property
    def request(self) -> typing.Optional[UserActivityRequest]: ...

class UserActivitySession(winrt.system.Object):
    def __enter__(self: Self) -> Self: ...
    def __exit__(self, *args) -> None: ...
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> UserActivitySession: ...
    def close(self) -> None: ...
    @_property
    def activity_id(self) -> str: ...

class UserActivitySessionHistoryItem(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> UserActivitySessionHistoryItem: ...
    @_property
    def end_time(self) -> typing.Optional[typing.Optional[datetime.datetime]]: ...
    @_property
    def start_time(self) -> datetime.datetime: ...
    @_property
    def user_activity(self) -> typing.Optional[UserActivity]: ...

class UserActivityVisualElements(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> UserActivityVisualElements: ...
    @_property
    def display_text(self) -> str: ...
    @display_text.setter
    def display_text(self, value: str) -> None: ...
    @_property
    def description(self) -> str: ...
    @description.setter
    def description(self, value: str) -> None: ...
    @_property
    def content(self) -> typing.Optional[winrt.windows.ui.shell.IAdaptiveCard]: ...
    @content.setter
    def content(self, value: typing.Optional[winrt.windows.ui.shell.IAdaptiveCard]) -> None: ...
    @_property
    def background_color(self) -> winrt.windows.ui.Color: ...
    @background_color.setter
    def background_color(self, value: winrt.windows.ui.Color) -> None: ...
    @_property
    def attribution(self) -> typing.Optional[UserActivityAttribution]: ...
    @attribution.setter
    def attribution(self, value: typing.Optional[UserActivityAttribution]) -> None: ...
    @_property
    def attribution_display_text(self) -> str: ...
    @attribution_display_text.setter
    def attribution_display_text(self, value: str) -> None: ...

class IUserActivityContentInfo(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> IUserActivityContentInfo: ...
    def to_json(self) -> str: ...

